package org.aleabodo.fireworksmc;

import org.bukkit.Color;
import org.bukkit.FireworkEffect;
import org.bukkit.Location;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Firework;
import org.bukkit.inventory.meta.FireworkMeta;
import org.bukkit.scheduler.BukkitRunnable;
import java.util.SortedMap;
import java.util.SortedSet;

public class Show {
    private long seed;
    private Location location;
    private Direction direction;
    private int duration; //in game-ticks
    private int bpm;
    private SortedSet<Integer> highlights;
    private SortedMap<Integer,Tempo> tempo;

    public Show(long seed, Location location, Direction direction, int duration, int bpm, SortedSet<Integer> highlights, SortedMap<Integer,Tempo> tempo) {
        this.seed = seed;
        this.location = location;
        this.direction = direction;
        this.duration = duration;
        this.bpm = bpm;
        this.highlights = highlights;
        this.tempo = tempo;
    }

    /*
     * Generate the firework show according to the random seed and the timings/highlights configured
     */
    public void generate() {

    }

    /**
     * Executes the firework show
     */
    public void start() {

    }

    /*
     * ################### GETTER ###################
     */

    public long getSeed() {
        return seed;
    }

    public Location getLocation() {
        return location;
    }

    public Direction getDirection() {
        return direction;
    }

    public int getDuration() {
        return duration;
    }

    public int getBpm() {
        return bpm;
    }

    /*
     * ################### SETTER ###################
     */

    public void setSeed(long seed) {
        this.seed = seed;
    }

    public void setLocation(Location location) {
        this.location = location;
    }

    public void setDirection(Direction direction) {
        this.direction = direction;
    }

    public void setDuration(int duration) {
        this.duration = duration;
    }

    public void setBpm(int bpm) {
        this.bpm = bpm;
    }
}
