package org.aleabodo.fireworksmc.Patterns;

public abstract class ScheduledThing implements Comparable<ScheduledThing>{
    protected int scheduleTime = 0;

    public abstract void schedule();

    protected void setScheduleTime(int scheduleTime) {
        this.scheduleTime = scheduleTime;
    }

    public int getScheduleTime() {
        return this.scheduleTime;
    }

    @Override
    public int compareTo(ScheduledThing other) {
        return this.scheduleTime - other.scheduleTime;
    }
}